#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#define  N	500000
void gen_data(int a[], int n);
inline void swap(int *x, int *y);
int  find_pivot(int *left, int *right, int *pivot_ptr);
int *partition(int *left, int *right, int pivot);
void quicksort(int *left, int * right);
void write_data(int a[], int n, char *name);
int main(void)
{
    int data[N], i;
    gen_data(data, N);
    quicksort(data, data + N - 1);
    write_data(data, N, "out");
    return 0;
}
void  gen_data(int a[], int n)
{
    int i;
    srand(time(NULL));
    for (i = 0; i < n; ++i)
        a[i] = rand() % 10000;
}
inline void  swap(int *x, int *y)
{
    int t;
    t = *x;
    *x = *y;
    *y = t;
}
void  quicksort(int *left, int * right)
{
    int  *p, pivot;
    if (find_pivot(left, right, &pivot)) {
        p = partition(left, right, pivot);
        quicksort(left, p - 1);
        quicksort(p, right);
    }
}
int find_pivot(int *left, int *right, int *pivot)
{
    int	a, b, c, *p;
    a = *left;
    b = *(left + (right - left) / 2);
    c = *right;
    if (a > b)
        if (b > c)
            swap(&a, &c);
        else
            swap(&a, &b);
    else if (a > c)
        swap(&a, &c);
    if (c < b)
        swap(&b, &c);
    if (a < b) {
        *pivot = b;
        return 1;
    }
    if (b < c) {
        *pivot = c;
        return 1;
    }
    for (p = left + 1; p <= right; ++p)
        if (*p != *left) {
            *pivot = (*p < *left) ? *left : *p;
            return 1;
        }
    return 0;
}
int *partition(int *left, int *right, int pivot)
{
    while (left <= right) {
        while (*left < pivot)
            ++left;
        while (*right >= pivot)
            --right;
        if (left < right) {
            swap(left, right);
            ++left;
            --right;
        }
    }
    return left;
}
void write_data(int a[], int n, char *name)
{
    int  i;
    FILE *fp;
    fp = fopen(name, "w");
    for (i = 0; i < n; i++)
        fprintf(fp, "%d\n", a[i]);
    fclose(fp);
}